[cfe-commits] r71201 - in /cfe/trunk/utils/ABITest: ABITestGen.py Makefile.test.common build-and-summarize-all.sh build-and-summarize.sh build.sh return-types-32/ return-types-32/Makefile return-types-64/ return-types-64/Makefile single-args-32/ single-args-64/ summarize.sh

Daniel Dunbar daniel at zuster.org
Thu May 7 17:49:22 PDT 2009


Author: ddunbar
Date: Thu May  7 19:49:21 2009
New Revision: 71201

URL: http://llvm.org/viewvc/llvm-project?rev=71201&view=rev
Log:
Add various other bits I use to run ABITest.

Added:
    cfe/trunk/utils/ABITest/Makefile.test.common
    cfe/trunk/utils/ABITest/build-and-summarize-all.sh   (with props)
    cfe/trunk/utils/ABITest/build-and-summarize.sh   (with props)
    cfe/trunk/utils/ABITest/build.sh   (with props)
    cfe/trunk/utils/ABITest/return-types-32/   (with props)
    cfe/trunk/utils/ABITest/return-types-32/Makefile
    cfe/trunk/utils/ABITest/return-types-64/   (with props)
    cfe/trunk/utils/ABITest/return-types-64/Makefile
    cfe/trunk/utils/ABITest/single-args-32/   (with props)
    cfe/trunk/utils/ABITest/single-args-64/   (with props)
    cfe/trunk/utils/ABITest/summarize.sh   (with props)
Modified:
    cfe/trunk/utils/ABITest/ABITestGen.py

Modified: cfe/trunk/utils/ABITest/ABITestGen.py
URL: http://llvm.org/viewvc/llvm-project/cfe/trunk/utils/ABITest/ABITestGen.py?rev=71201&r1=71200&r2=71201&view=diff

==============================================================================
--- cfe/trunk/utils/ABITest/ABITestGen.py (original)
+++ cfe/trunk/utils/ABITest/ABITestGen.py Thu May  7 19:49:21 2009
@@ -430,7 +430,7 @@
                      action="store", type=str, default='v2i16, v1i64, v2i32, v4i16, v8i8, v2f32, v2i64, v4i32, v8i16, v16i8, v2f64, v4f32, v16f32', metavar="N")
     group.add_option("", "--bit-fields", dest="bitFields",
                      help="comma separated list 'type:width' bit-field specifiers [default %default]",
-                     action="store", type=str, default="1,3,-2,-1")
+                     action="store", type=str, default="char:0,char:4,unsigned:0,unsigned:13")
     group.add_option("", "--max-args", dest="functionMaxArgs",
                      help="maximum number of arguments per function [default %default]",
                      action="store", type=int, default=4, metavar="N")

Added: cfe/trunk/utils/ABITest/Makefile.test.common
URL: http://llvm.org/viewvc/llvm-project/cfe/trunk/utils/ABITest/Makefile.test.common?rev=71201&view=auto

==============================================================================
--- cfe/trunk/utils/ABITest/Makefile.test.common (added)
+++ cfe/trunk/utils/ABITest/Makefile.test.common Thu May  7 19:49:21 2009
@@ -0,0 +1,149 @@
+# -*- Makefile -*-
+
+ABITESTGEN := ../ABITestGen.py
+
+ifndef VERBOSE
+  Verb := @
+endif
+
+.PHONY: test.%.report
+test.%.report: temps/test.%.xx.diff temps/test.%.xy.diff temps/test.%.yx.diff temps/test.%.yy.diff
+	@ok=1;\
+	for t in $^; do \
+		if [ -s $$t ]; then \
+			echo "TEST $*: $$t failed"; \
+			ok=0;\
+		fi; \
+	done; \
+	if [ $$ok == 1 ]; then \
+		true; \
+	else \
+		false; \
+	fi
+
+
+.PHONY: test.%.defs-report
+test.%.defs-report: temps/test.%.defs.diff
+	@for t in $^; do \
+		if [ -s $$t ]; then \
+			echo "TEST $*: $$t failed"; \
+			cat $$t; \
+		fi; \
+	done
+
+.PHONY: test.%.build
+test.%.build: temps/test.%.ref temps/test.%.xx temps/test.%.xy temps/test.%.yx temps/test.%.yy temps/test.%.x.defs temps/test.%.y.defs
+	@true
+
+###
+
+# Diffs and output
+
+.PRECIOUS: temps/.dir
+
+.PRECIOUS: temps/test.%.xx.diff
+temps/test.%.xx.diff: temps/test.%.ref.out temps/test.%.xx.out
+	$(Verb) diff $^ > $@ || true
+.PRECIOUS: temps/test.%.xy.diff
+temps/test.%.xy.diff: temps/test.%.ref.out temps/test.%.xy.out
+	$(Verb) diff $^ > $@ || true
+.PRECIOUS: temps/test.%.yx.diff
+temps/test.%.yx.diff: temps/test.%.ref.out temps/test.%.yx.out
+	$(Verb) diff $^ > $@ || true
+.PRECIOUS: temps/test.%.yy.diff
+temps/test.%.yy.diff: temps/test.%.ref.out temps/test.%.yy.out
+	$(Verb) diff $^ > $@ || true
+.PRECIOUS: temps/test.%.defs.diff
+temps/test.%.defs.diff: temps/test.%.x.defs temps/test.%.y.defs
+	$(Verb) zipdifflines \
+	  --replace "%struct.T[0-9]+" "%struct.s" \
+	  --replace "%union.T[0-9]+" "%struct.s" \
+	  --replace "byval align [0-9]+" "byval" \
+	  $^ > $@
+
+.PRECIOUS: temps/test.%.out
+temps/test.%.out: temps/test.%
+	-$(Verb) ./$< > $@
+
+# Executables
+
+.PRECIOUS: temps/test.%.ref
+temps/test.%.ref: temps/test.%.driver.ref.o temps/test.%.a.ref.o temps/test.%.b.ref.o
+	$(Verb) $(CC) $(CFLAGS) $(CC_CFLAGS) -O3 -o $@ $^
+.PRECIOUS: temps/test.%.xx
+temps/test.%.xx: temps/test.%.driver.ref.o temps/test.%.a.x.o temps/test.%.b.x.o
+	$(Verb) $(CC) $(CFLAGS) $(CC_CFLAGS) -O3  -o $@ $^
+.PRECIOUS: temps/test.%.xy
+temps/test.%.xy: temps/test.%.driver.ref.o temps/test.%.a.x.o temps/test.%.b.y.o
+	$(Verb) $(CC) $(CFLAGS) $(CC_CFLAGS) -O3  -o $@ $^
+.PRECIOUS: temps/test.%.yx
+temps/test.%.yx: temps/test.%.driver.ref.o temps/test.%.a.y.o temps/test.%.b.x.o
+	$(Verb) $(CC) $(CFLAGS) $(CC_CFLAGS) -O3  -o $@ $^
+.PRECIOUS: temps/test.%.yy
+temps/test.%.yy: temps/test.%.driver.ref.o temps/test.%.a.y.o temps/test.%.b.y.o
+	$(Verb) $(CC) $(CFLAGS) $(CC_CFLAGS) -O3  -o $@ $^
+
+# Object files
+
+.PRECIOUS: temps/test.%.ref.o
+temps/test.%.ref.o: inputs/test.%.c temps/.dir
+	$(Verb) $(CC) -c $(CFLAGS) $(CC_CFLAGS) -o $@ $<
+.PRECIOUS: temps/test.%.x.o
+temps/test.%.x.o: inputs/test.%.c temps/.dir
+	$(Verb) $(X_COMPILER) -c $(CFLAGS) $(X_CFLAGS) -o $@ $<
+.PRECIOUS: temps/test.%.y.o
+temps/test.%.y.o: inputs/test.%.c temps/.dir
+	$(Verb) $(Y_COMPILER) -c $(CFLAGS) $(Y_CFLAGS) -o $@ $<
+
+.PRECIOUS: temps/test.%.x.defs
+temps/test.%.x.defs: temps/test.%.a.x.ll temps/.dir
+	-$(Verb) -grep '^define ' $< > $@
+.PRECIOUS: temps/test.%.y.defs
+temps/test.%.y.defs: temps/test.%.a.y.ll temps/.dir
+	-$(Verb) -grep '^define ' $< > $@
+
+.PRECIOUS: temps/test.%.a.x.ll
+temps/test.%.a.x.ll: inputs/test.%.a.c temps/.dir
+	$(Verb) $(X_COMPILER) $(CFLAGS) $(X_LL_CFLAGS) $(X_CFLAGS) -o $@ $<
+.PRECIOUS: temps/test.%.b.x.ll
+temps/test.%.b.x.ll: inputs/test.%.b.c temps/.dir
+	$(Verb) $(X_COMPILER) $(CFLAGS) $(X_LL_CFLAGS) $(X_CFLAGS) -o $@ $<
+.PRECIOUS: temps/test.%.a.y.ll
+temps/test.%.a.y.ll: inputs/test.%.a.c temps/.dir
+	$(Verb) $(Y_COMPILER) $(CFLAGS) $(Y_LL_CFLAGS) $(Y_CFLAGS) -o $@ $<
+.PRECIOUS: temps/test.%.b.y.ll
+temps/test.%.b.y.ll: inputs/test.%.b.c temps/.dir
+	$(Verb) $(Y_COMPILER) $(CFLAGS) $(Y_LL_CFLAGS) $(Y_CFLAGS) -o $@ $<
+
+# Input generation
+
+.PHONY: test.%.top
+test.%.top: inputs/test.%.a.c inputs/test.%.b.c inputs/test.%.driver.c
+	@true
+
+.PRECIOUS: inputs/test.%.a.c inputs/test.%.b.c inputs/test.%.driver.c
+inputs/test.%.a.c: test.%.generate
+	@true
+inputs/test.%.b.c: test.%.generate
+	@true
+inputs/test.%.driver.c: test.%.generate
+	@true
+
+.PHONY: test.%.generate
+.PRECIOUS: inputs/.dir
+test.%.generate: $(ABITESTGEN) inputs/.dir
+	$(Verb) $(ABITESTGEN) $(TESTARGS) -o inputs/test.$*.a.c -T inputs/test.$*.b.c -D inputs/test.$*.driver.c --min=$(shell expr $* '*' $(COUNT))  --count=$(COUNT)
+
+# Cleaning
+
+clean-temps:
+	$(Verb) rm -rf temps
+
+clean:
+	$(Verb) rm -rf temps inputs
+
+# Etc.
+
+%/.dir:
+	$(Verb) mkdir -p $* > /dev/null
+	$(Verb) $(DATE) > $@

Added: cfe/trunk/utils/ABITest/build-and-summarize-all.sh
URL: http://llvm.org/viewvc/llvm-project/cfe/trunk/utils/ABITest/build-and-summarize-all.sh?rev=71201&view=auto

==============================================================================
--- cfe/trunk/utils/ABITest/build-and-summarize-all.sh (added)
+++ cfe/trunk/utils/ABITest/build-and-summarize-all.sh Thu May  7 19:49:21 2009
@@ -0,0 +1,15 @@
+#!/bin/sh
+
+set -eu
+
+if [ $# != 1 ]; then
+    echo "usage: $0 <num-tests>"
+    exit 1
+fi
+
+for bits in 32 64; do
+    for kind in return-types single-args; do
+        echo "-- $kind-$bits --"
+        (cd $kind-$bits && ../build-and-summarize.sh $1)
+    done
+done

Propchange: cfe/trunk/utils/ABITest/build-and-summarize-all.sh

------------------------------------------------------------------------------
    svn:executable = *

Added: cfe/trunk/utils/ABITest/build-and-summarize.sh
URL: http://llvm.org/viewvc/llvm-project/cfe/trunk/utils/ABITest/build-and-summarize.sh?rev=71201&view=auto

==============================================================================
--- cfe/trunk/utils/ABITest/build-and-summarize.sh (added)
+++ cfe/trunk/utils/ABITest/build-and-summarize.sh Thu May  7 19:49:21 2009
@@ -0,0 +1,14 @@
+#!/bin/sh
+
+set -eu
+
+if [ $# != 1 ]; then
+    echo "usage: $0 <num-tests>"
+    exit 1
+fi
+
+dir=$(dirname $0)
+$dir/build.sh $1 &> /dev/null || true
+../summarize.sh $1 &> fails-x.txt
+cat fails-x.txt
+wc -l fails-x.txt

Propchange: cfe/trunk/utils/ABITest/build-and-summarize.sh

------------------------------------------------------------------------------
    svn:executable = *

Added: cfe/trunk/utils/ABITest/build.sh
URL: http://llvm.org/viewvc/llvm-project/cfe/trunk/utils/ABITest/build.sh?rev=71201&view=auto

==============================================================================
--- cfe/trunk/utils/ABITest/build.sh (added)
+++ cfe/trunk/utils/ABITest/build.sh Thu May  7 19:49:21 2009
@@ -0,0 +1,12 @@
+#!/bin/sh
+
+set -eu
+
+if [ $# != 1 ]; then
+    echo "usage: $0 <num-tests>"
+    exit 1
+fi
+
+CPUS=$(sysctl -n hw.ncpu)
+make -j $CPUS \
+  $(for i in $(zseq 0 $1); do echo test.$i.report; done) -k

Propchange: cfe/trunk/utils/ABITest/build.sh

------------------------------------------------------------------------------
    svn:executable = *

Propchange: cfe/trunk/utils/ABITest/return-types-32/

------------------------------------------------------------------------------
--- svn:ignore (added)
+++ svn:ignore Thu May  7 19:49:21 2009
@@ -0,0 +1,3 @@
+history
+inputs
+temps

Added: cfe/trunk/utils/ABITest/return-types-32/Makefile
URL: http://llvm.org/viewvc/llvm-project/cfe/trunk/utils/ABITest/return-types-32/Makefile?rev=71201&view=auto

==============================================================================
--- cfe/trunk/utils/ABITest/return-types-32/Makefile (added)
+++ cfe/trunk/utils/ABITest/return-types-32/Makefile Thu May  7 19:49:21 2009
@@ -0,0 +1,23 @@
+# Usage: make test.N.report 
+#
+# COUNT can be over-ridden to change the number of tests generated per
+# file, and TESTARGS is used to change the type generation. Make sure
+# to 'make clean' after changing either of these parameters.
+
+TESTARGS := --no-vector --no-complex --max-record-depth 0 --bit-fields "char:2,char:0,char:4" --max-args 0 --max-record 2 --no-builtins
+COUNT := 1
+TIMEOUT := 5
+
+CFLAGS := -std=gnu99
+
+X_COMPILER := gcc
+X_LL_CFLAGS := -emit-llvm -S
+Y_COMPILER := clang
+Y_LL_CFLAGS := -emit-llvm -S
+CC := gcc
+
+X_CFLAGS := -m32
+Y_CFLAGS := -m32
+CC_CFLAGS := -m32
+
+include ../Makefile.test.common

Propchange: cfe/trunk/utils/ABITest/return-types-64/

------------------------------------------------------------------------------
--- svn:ignore (added)
+++ svn:ignore Thu May  7 19:49:21 2009
@@ -0,0 +1,3 @@
+history
+inputs
+temps

Added: cfe/trunk/utils/ABITest/return-types-64/Makefile
URL: http://llvm.org/viewvc/llvm-project/cfe/trunk/utils/ABITest/return-types-64/Makefile?rev=71201&view=auto

==============================================================================
--- cfe/trunk/utils/ABITest/return-types-64/Makefile (added)
+++ cfe/trunk/utils/ABITest/return-types-64/Makefile Thu May  7 19:49:21 2009
@@ -0,0 +1,23 @@
+# Usage: make test.N.report 
+#
+# COUNT can be over-ridden to change the number of tests generated per
+# file, and TESTARGS is used to change the type generation. Make sure
+# to 'make clean' after changing either of these parameters.
+
+TESTARGS := --max-args 0 --no-unsigned --no-bit-field
+COUNT := 1
+TIMEOUT := 5
+
+CFLAGS := -std=gnu99
+
+X_COMPILER := gcc
+X_LL_CFLAGS := -emit-llvm -S
+Y_COMPILER := clang
+Y_LL_CFLAGS := -emit-llvm -S
+CC := gcc
+
+X_CFLAGS := -m64
+Y_CFLAGS := -m64
+CC_CFLAGS := -m64
+
+include ../Makefile.test.common

Propchange: cfe/trunk/utils/ABITest/single-args-32/

------------------------------------------------------------------------------
--- svn:ignore (added)
+++ svn:ignore Thu May  7 19:49:21 2009
@@ -0,0 +1,3 @@
+history
+inputs
+temps

Propchange: cfe/trunk/utils/ABITest/single-args-64/

------------------------------------------------------------------------------
--- svn:ignore (added)
+++ svn:ignore Thu May  7 19:49:21 2009
@@ -0,0 +1,3 @@
+history
+inputs
+temps

Added: cfe/trunk/utils/ABITest/summarize.sh
URL: http://llvm.org/viewvc/llvm-project/cfe/trunk/utils/ABITest/summarize.sh?rev=71201&view=auto

==============================================================================
--- cfe/trunk/utils/ABITest/summarize.sh (added)
+++ cfe/trunk/utils/ABITest/summarize.sh Thu May  7 19:49:21 2009
@@ -0,0 +1,15 @@
+#!/bin/sh
+
+set -eu
+
+if [ $# != 1 ]; then
+    echo "usage: $0 <num-tests>"
+    exit 1
+fi
+
+for i in $(zseq 0 $1); do 
+    if (! make test.$i.report &> /dev/null); then 
+        echo "FAIL: $i";
+    fi; 
+done
+

Propchange: cfe/trunk/utils/ABITest/summarize.sh

------------------------------------------------------------------------------
    svn:executable = *





More information about the cfe-commits mailing list